<template>
  <single-panel>
    <header class="distibution-header">
      <div class="distibution-header__link" @click="$router.go(-1)">
        <i class="icon chevron-left"></i>
        Услуги
      </div>
      <span>
        {{ activeService.serviceTypeTitle }}. {{ activeService.resourceTitle ? activeService.resourceTitle+'.' : '' }} {{ activeService.serviceUnitTitle }}
      </span>
    </header>

    <div v-if="!rule.directions.length" class="no-content">
      <p>Распределение не настроено. Добавьте направления</p>
      <span v-if="rule.titul.status === 'DRAFT' || rule.titul.status === 'STOPPED'" @click="addNew">Добавить направление</span>
    </div>

    <div v-else class="distribution">
      <div class="distribution__action">
        <ob-button v-if="rule.titul.status === 'DRAFT' || rule.titul.status === 'STOPPED'" label="Добавить направление" @click="addNew" />
      </div>
      <nav class="distribution__nav">
        <ob-tabs v-model="activeTab" :items="tabsItems" :no-border="true" />
      </nav>

      <div class="distribution__content">
        <transition name="fadeIn" mode="out-in">
          <keep-alive>
            <component
              :ref="activeComponent"
              :style="{ transitionDuration: '0.1s' }"
              :is="activeComponent"
              @selected="onSelect"
            />
          </keep-alive>
        </transition>
      </div>
    </div>

    <ob-modal
      ref="distributionModal"
      size="large"
      title="Распределение заказов"
      @closed="onClose"
    >
      <distribution-modal
        ref="distributionForm"
        :direction="activeDirection"
        @cancel="$refs.distributionModal.close()"
        @save="onSave"
      />
    </ob-modal>
  </single-panel>
</template>

<script>
import { mapGetters, mapActions } from "vuex";
import api from "@/api";
import singlePanel from "common-components/src/obComponents/obSinglePanels";
import ObButton from "common-components/src/obComponents/obButton";
import ObTabs from "common-components/src/obComponents/obTabs";
import obModal from "common-components/src/obComponents/obModal";
import distributionModal from "./distributionModal";
import directionsTabComponent from "./directionsTab";
import conrtactorsTabComponent from "./contractorsTab";

export default {
  name: "serviceDirections",

  components: {
    singlePanel,
    ObButton,
    ObTabs,
    obModal,
    distributionModal,
    directionsTabComponent,
    conrtactorsTabComponent
  },

  data() {
    return {
      showServices: false,
      activeTab: {
        uuid: "directions",
        title: "Распределённые рейсы по направлениям",
      },
      activeDirection: null
    };
  },

  computed: {
    ...mapGetters({
      rule: "tms/rule",
    }),

    serviceUuid() {
      return this.$route.params.service;
    },

    activeService() {
      return this.rule.services.find(item => item.uuid === this.serviceUuid);
    },

    tabsItems() {
      return [
        {
          uuid: "directions",
          title: "Распределённые рейсы по направлениям",
        },
        {
          uuid: "contractors",
          title: "По исполнителям",
        },
      ];
    },

    activeComponent() {
      let componentsMap = {
        directions: directionsTabComponent,
        contractors: conrtactorsTabComponent,
      };
      return componentsMap[this.activeTab.uuid];
    },
  },

  async created() {
    if (!this.rule.uuid.length) {
      this.$router.push('/tms');
      return;
    }
    await this.getDirections();
    await this.getDirectionsByContractors();
  },

  methods: {
    ...mapActions({
      setRuleDirections: 'tms/setRuleDirections',
      setRuleDirectionsByContractors: 'tms/setRuleDirectionsByContractors'   
    }),

    onClose() {
      this.activeDirection = null;
      this.$refs.distributionForm.reset();
    },

    async getDirections() {
      try {
        const res = await api.tms.getDirections(this.serviceUuid);
        this.setRuleDirections(res);
      } catch (e) {
        console.error(e);
      }
    },

    async getDirectionsByContractors() {
      try {
        const res = await api.tms.getDirectionsByContractors(this.serviceUuid);
        this.setRuleDirectionsByContractors(res);
      } catch (e) {
        console.error(e);
      }
    },

    addNew() {
      this.activeDirection = null;
      this.showDistModal();
    },
    
    showDistModal() {
      this.$refs.distributionModal.open();
    },

    async onSave() {
      this.$refs.distributionModal.close();
      await this.getDirections();
      await this.getDirectionsByContractors();
    },

    async onSelect($event) {
      try {
        const res = await api.tms.getDirectionDetails($event);
        this.activeDirection = {
          uuid: $event,
          fromPoint: {
          address: {
            label: res.fromLocationTitle,
            coordinates: [],
            icon: "",
          },
          locationTitle: res.fromLocationTitle,
          locationTypeIcon: "",
          locationUuid: res.fromLocationUuid,
        },
        toPoint: {
          address: {
            label: res.toLocationTitle,
            coordinates: [],
            icon: "",
          },
          locationTitle: res.toLocationTitle,
          locationTypeIcon: "",
          locationUuid: res.toLocationUuid,
        },
        selectedContractors: res.participantVolumes.map(item => ({uuid: item.participantUuid, title: item.participantTitle, value: item.volume, isWrong: false, icon: ''})),
        }
        this.showDistModal();
      } catch (e) {
        console.error(e);
      }
    },
  },
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.distribution {
  flex-grow: 1;
  display: flex;
  flex-direction: column;
}

.distibution-header {
  display: flex;
  align-items: center;
  padding: 20px 25px;
  position: relative;
  z-index: 2;
  background-color: #fff;
  @include font-mixin(16px, 20px, 400, $style-black);
  border-bottom: 1px solid $color-grey-border;

  .distibution-header__link {
    margin-right: 20px;
    display: flex;
    align-items: center;
    color: $color-blue-smalt;
  }

  i {
    font-size: 16px;
    color: $color-blue-navy-blue;
    position: relative;
    top: -2px;
    margin-right: 10px;
  }

  div {
    cursor: pointer;
  }
}

.distribution__content {
  flex-grow: 1;
}

.no-content {
  height: 100%;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;

  p {
    @include font-mixin(24px, 40px, 400, $color-grey-span);
  }

  span {
    margin-top: 20px;
    @include font-mixin(16px, 20px, 400, $color-blue-navy-blue);
    text-decoration: none;
    cursor: pointer;
  }
}

.distribution__action {
  position: relative;
  z-index: 2;
  padding: 25px;
  background-color: #fff;
}

.distribution__nav {
  position: relative;
  z-index: 1;
  padding-left: 25px;
  padding-right: 25px;
  @include font-mixin(16px, 20px, 400, $gray-slate, 0.4px);
  box-shadow: 0 2px 8px rgba(0, 75, 200, 0.14);
}
</style>
